Subject: RE: [External] : bug#52870: Is displaying <menu-bar> bindings in describe-function useful?

From: Drew Adams <[email-masked]>
Date: Sun, 16 Jan 2022 02:59:18 +0000

> Drew Adams <[email-masked]> writes:
> 
> >> FWIW I think it would be a good idea to do something like this:
> >>
> >>   It is bound to C-h f, <help> f, <menu-bar> <help-menu> <describe>
> >>   <describe-function> (which means it can be invoked from the menu:
> >>   "Help Menu" -> "Describe" ...).

You give the impression that Drew Adams said
what you quoted.  A careful reader might
notice that the quoted text is not from me;
others might not.  Why do that?

> IMO, that would be a step backwards.  This bug report started out with
> me saying that this information is already confusing and distracting,
> and this would make it even more so.

Why would providing additional information
about where that menu command can be found
in the menu be confusing?

To be clear, as I said, no change is needed.
Nothing is broken, confusing, or distracting.

But if someone wants to add more info, that's
OK too.

> I don't think we should pretend that menu items are key bindings, because
> they are not.

They certainly are - for Emacs.  Always have
been, ever since we've had menus.

> That is just an implementation detail.

No, it's not.  It's the way Emacs itself
talks about menu-item key bindings. 

> Our user manual correctly contrasts the two:
> 
>     "Each Emacs frame normally has a 'menu bar' at the top which you can use
>     to perform common operations ...
> 
>        "On a display that supports a mouse, you can use the mouse to choose
> a
>     command from the menu bar ...
> 
>        "Some of the commands in the menu bar have ordinary key bindings as
>     well; if so, a key binding is shown after the item itself."

Nothing there contradicts Emacs's treatment
everywhere of these as key bindings.  Yes,
that last sentence would be clearer if it
said "keyboard key bindings" instead of
"ordinary key bindings".

"Keyboard key bindings" is _very_ clear.
"Ordinary" means nothing here - that wording
is a bug.

Is a function-key binding an "ordinary" key
binding?  What about a function-key that's
not associated with a physical keyboard key?

Please don't try to change the longstanding
and very clear Emacs nomenclature about key
bindings.

Is the _text_ of a menu item the same as the
menu item?  If so, then your uses of "menu
item" above are incorrect - the text is not
bound.  But if not, then yes, menu items are
key bindings.  They're bound in a menu keymap.

And yes, it's important that Emacs itself,
when it speaks to users, use the same terms
as when it talks about Elisp entities.  Emacs
users are very often Elisp users.

And Elisp and its entities are not just
"implementation details".  Far from it, thank
goodness.